module Kernel
  # Stae zdefiniowane w module Kernel.
  A = B = C = D = E = F = "zdefiniowane w module Kernel"
end
# Stae globalne zdefiniowane w klasie Object.
A = B = C = D = E = "zdefiniowane na najwyszym poziomie"
class Super
  # Stae zdefiniowane w nadklasie.
  A = B = C = D = "zdefiniowane w nadklasie"
end
module Included
  # Stae zdefiniowane w doczonym module.
  A = B = C = "zdefiniowane w doczonym module"
end
module Enclosing
  # Stae zdefiniowane w module nadrzdnym.
  A = B = "zdefiniowane w module nadrzdnym"
  class Local < Super
    include Included
    # Staa zdefiniowana lokalnie.
    A = "zdefiniowana lokalnie"
    # Lista przeszukiwanych moduw w kolejnoci przeszukiwania.
    # [Enclosing::Local, Enclosing, Included, Super, Object, Kernel]
    search = (Module.nesting + self.ancestors + Object.ancestors).uniq
    puts A  # Drukuje zdefiniowane lokalnie
    puts B  # Drukuje zdefiniowane w module nadrzdnym
    puts C  # Drukuje zdefiniowane w doczonym module
    puts D  # Drukuje zdefiniowane w nadklasie
    puts E  # Drukuje zdefiniowane na najwyszym poziomie
    puts F  # Drukuje zdefiniowane w module Kernel
  end
end
